#include <stdio.h>
#include <stdlib.h>

#define MAX_VALUE 100
#define ROWS 3
#define COLS 4

void fill(int n, int *v);

void print_values(int n, int *a);

void print(int rows, int cols, int m[][cols]);

int main(int argc, char *argv[])
{
   const int n = ROWS * COLS;

   int array[n];
   int *p = array;

   fill(n, p);
   print_values(n, p);

   int (*m)[COLS] = (int(*)[COLS])p;
   printf("\nPrint as matrix %d x %d\n", ROWS, COLS);
   // print(ROWS, COLS, p); //Not compatible types
   print(ROWS, COLS, m);

   printf("\nPrint as matrix %d x %d\n", COLS, ROWS);
   print(COLS, ROWS, m);

   return 0;
}

void fill(int n, int *v)
{
   for (int i = 0; i < n; ++i) {
      v[i] = rand() % MAX_VALUE;
   }
}

void print_values(int n, int *a)
{
   for (int i = 0; i < n; ++i) {
      printf("%s%i", (i > 0 ? " " : ""), a[i]);
   }
   putchar('\n');
}

void print(int rows, int cols, int m[][cols])
{
   for (int r = 0; r < rows; ++r) {
      for (int c = 0; c < cols; ++c) {
	 printf("%3i", m[r][c]);
      }
      putchar('\n');
   }
}
